
DefineClass.MyAttackDrone = {
	__parents = {
	"BaseAttacker"
	},
	display_name = T{"战斗无人机"},
	description = T{"火星大魔王派来的战斗无人机，近战王者"},
	reclaimed_description = T{"火星大魔王赠送的战斗无人机，近战王者"},
	display_icon = "UI/Icons/Buildings/drone.tga",
	attack_range = 130 * guim,
	rocket_damage = 25,
	move_speed = 2000,
	entity = "DroneMaintenance",
	default_skins = {
	"Drone_Trailblazer",
	"DroneMaintenance"
	},
	fx_actor_class = "Drone"
	
}
DefineClass.MyAttackDroneBuilding = {
  __parents = {
    "BaseRoverBuilding"
  },
  rover_class = "MyAttackDrone"
}

function MyAttackDrone:GameInit()
  local city = self.city or UICity
  self.display_name = T{"战斗无人机"}
  self.reclaimed_description = T{"火星大魔王赠送的战斗无人机，近战王者"}
  self.description = T{"火星大魔王派来的战斗无人机，近战王者"}
  self:SetScale(500)
  if self.reclaimed then
      city:RemoveFromLabel("HostileAttackers", self)
	  city:AddToLabel("Rover", self)
  else 
	  city:RemoveFromLabel("Rover", self)
	  city:AddToLabel("HostileAttackers", self)
  end
  if self.need_spawn then
	self:SetCommand("Spawn")
  else
    self:SetCommand("Idle")
  end
end


function MyAttackDrone:FireRocket(luaobj, rocket_class)
  -- rocket_class = rocket_class or "RocketProjectile"
  -- self:SetAnim(1, "attackStart")
  -- Sleep(self:TimeToAnimEnd())
  -- self:SetAnim(1, "attackIdle")
  -- Sleep(500)
  -- local rocket = PlaceObject(rocket_class, luaobj)
  -- local spot = self:GetSpotBeginIndex("Rocket")
  -- local pos = self:GetSpotLoc(spot)
	-- 这里需要重新判断一下状态
	local needAttack = false
	if IsValid(luaobj.target) then
		if IsKindOf(luaobj.target, "Building") and not luaobj.target.destroyed and not luaobj.target:IsMalfunctioned() then
			needAttack = true
		end
		if not IsKindOf(luaobj.target, "Building") and not (luaobj.target:IsDead() or luaobj.target:IsMalfunctioned()) then
			needAttack = true
		end
	end
	-- 如果状态不对， 就直接退出
	if not needAttack then return end
  self:GotoSameDomeAsObj(luaobj.target)
  self:Goto(luaobj.target, 2 * guim, 0)
  -- self:Face(luaobj.target:GetPos(), 100)
  self:Face(luaobj.target)
  self:SetAnim(1, "rogueAttack")
  Sleep(self:TimeToAnimEnd())
  
  -- self:StartFX("Charging", self, luaobj.target)
  -- self:StartFX("Repair", luaobj.target)
  -- self:PlayState("repairDroneStart")
  -- self:PlayState("repairDroneIdle", g_Consts.DroneRepairAnimReps, const.eDontCrossfade)
  -- self:StartFX("Charging", self)
  self:StartFX("Repair", self)
  self:PlayState("repairDroneStart")
  self:PlayState("repairDroneIdle", g_Consts.DroneRepairAnimReps, const.eDontCrossfade)
  self:PlayState("repairDroneEnd", 1, const.eDontCrossfade)
  PlayFX("DroneExplode", "start", luaobj.target)
  self:HitTarget(luaobj.target)
  self:StopFX()
  Sleep(1)
  
  -- self:PlayState("rechargeDroneStart")
  -- self:PlayState("rechargeDroneIdle", 8, const.eDontCrossfade)
  -- rocket.shooter = self
  -- rocket:SetPos(pos)
  -- rocket.move_dir = axis_y
  -- rocket:StartMoving()
  -- PlayFX("MissileFired", "start", self, nil, pos, axis_y)
  --self:SetAnim(1, "attackEnd")
  -- Sleep(self:TimeToAnimEnd())
end

