
DefineClass.MyAttackFemale = {
	__parents = {
	"BaseAttacker"
	},
	display_name = T{"阿修罗"},
	description = T{"火星大魔王的子民拥有魔法技能闪电风暴, 群攻法师"},
	reclaimed_description = T{"归顺的阿修罗，群攻法师"},
	display_icon = "UI/Icons/Buildings/res_shuttle.tga",
	attack_range = 30 * guim,
	rocket_damage = 15,
	move_speed = 1000,
	entity = "Female",
	default_skins = {},
	fx_actor_class = "ColonistFemale",
	time_required_for_demolish = 1000,
	
}

DefineClass.MyAttackFemaleBuilding = {
  __parents = {
    "BaseRoverBuilding"
  },
  rover_class = "MyAttackFemale"
}

function MyAttackFemale:GameInit()
  local city = self.city or UICity
  self.display_name = T{"阿修罗"}
  self.reclaimed_description = T{"火星大魔王的子民拥有魔法技能闪电风暴, 群攻法师"}
  self.description = T{"归顺的阿修罗，群攻法师"}
  self:SetScale(500)
  if self.reclaimed then
      city:RemoveFromLabel("HostileAttackers", self)
	  city:AddToLabel("Rover", self)
  else 
	  city:RemoveFromLabel("Rover", self)
	  city:AddToLabel("HostileAttackers", self)
  end
  if self.need_spawn then
	self:SetCommand("Spawn")
  else
    self:SetCommand("Idle")
  end
end

function MyAttackFemale:Dead()
  if not self.reclaimed then
    Msg("AttackRoverDead", self)
	Msg("HostileOnDead", self)
    self:SetCommand("Malfunction")
  end
  local city = self.city or UICity
  city:RemoveFromLabel("HostileAttackers", self)
  DelayedCall(2000, function()
		self:ToggleDemolish()
  end)
	
  BaseRover.Dead(self)
  ObjModified(self)
end


function MyAttackFemale:FireRocket(luaobj, rocket_class)

  self:GotoSameDomeAsObj(luaobj.target)
  self:Goto(luaobj.target, 2 * guim, 0)
  -- self:Face(luaobj.target:GetPos(), 100)
  
  -- 这里需要重新判断一下状态
	local needAttack = false
	if IsValid(luaobj.target) then
		if IsKindOf(luaobj.target, "Building") and not luaobj.target.destroyed and not luaobj.target:IsMalfunctioned() then
			needAttack = true
		end
		if not IsKindOf(luaobj.target, "Building") and not (luaobj.target:IsDead() or luaobj.target:IsMalfunctioned()) then
			needAttack = true
		end
	end
	-- 如果状态不对， 就直接退出
	if not needAttack then return end
	
  self:Face(luaobj.target)
  self:SetAnim(1, "attackStart")
  Sleep(self:TimeToAnimEnd())
  self:SetAnim(1, "attackIdle")
  PlayFX("Shoot", "start", self, luaobj.target)
  Sleep(self:TimeToAnimEnd())
  local strike_pos = luaobj.target:GetPos()
  local strike_radius = self.attack_range
  PlayFX("ElectrostaticStorm", "start")
  PlayFX("ElectrostaticStormArea", "start", nil, nil, strike_pos)
  PlayFX("ElectrostaticStorm", "hit-moment" .. tostring(1 + UICity:Random(4)), nil, nil, strike_pos)
  
   ForEach({
          classes = "Colonist,Building,Drone,BaseRover,ResourceStockpileBase",
          area = strike_pos,
          arearadius = strike_radius + GetEntityMaxSurfacesRadius(),
          exec = function(obj)
            -- if not obj:IsCloser2D(strike_pos, strike_radius) or IsObjInDome(obj) or obj == self then
			if not obj:IsCloser2D(strike_pos, strike_radius) or obj == self then
              return
            end
            PlayFX("ElectrostaticStormObject", "start", nil, obj, strike_pos)
			CreateGameTimeThread(function()
				self:HitTarget(obj)
			end)
          end
    })
  -- PlayFX("ElectrostaticStormObject", "start", nil, luaobj.target, luaobj.target:GetPos())
  PlayFX("GetShot", "start", luaobj.target)
  -- self:HitTarget(luaobj.target)
  PlayFX("ElectrostaticStorm", "end")
  self:SetAnim(1, "attackEnd")
  Sleep(self:TimeToAnimEnd())
  
end